import type * as BabelCoreNamespace from '@babel/core';
import type * as BabelTypesNamespace from '@babel/types';
import { Options } from '.';
export declare type Babel = typeof BabelCoreNamespace;
export declare type BabelTypes = typeof BabelTypesNamespace;
export declare type ProgramNodePath = BabelCoreNamespace.NodePath<BabelCoreNamespace.types.Program>;
export interface PluginState {
    /** Whether need transform */
    needTransform: boolean;
    /** All react specifiers after merge */
    reactSpecifier: (BabelCoreNamespace.types.ImportSpecifier | BabelCoreNamespace.types.ImportDefaultSpecifier)[];
    /** Components' name ready to split */
    compNames: string[];
}
/**
 * Plugin Instance
 */
export default class RuiPlugin {
    private state;
    types: BabelTypes;
    opts: Required<Options>;
    constructor(types: BabelTypes, opts: Options);
    getState(): PluginState;
    updateState<K extends keyof PluginState>(key: K, payload: PluginState[K] | ((prev: PluginState[K]) => PluginState[K])): void;
    resetState(): void;
    /** First inspect, determine if need transform */
    inspect(path: ProgramNodePath): void;
    /** Add all react import in the end */
    addReactImport(path: ProgramNodePath): void;
    /** Overwrite AST related to components */
    overwriteComponents(path: ProgramNodePath): void;
}
